from cpl_core.logging import LoggerABC
from cpl_discord.events.on_raw_reaction_add_abc import OnRawReactionAddABC
from cpl_discord.service import DiscordBotServiceABC
from discord import RawReactionActionEvent

from bot_data.abc.auto_role_repository_abc import AutoRoleRepositoryABC
from bot_data.abc.server_repository_abc import ServerRepositoryABC
from modules.auto_role.helper.reaction_handler import ReactionHandler


class AutoRoleOnRawReactionAddEvent(OnRawReactionAddABC):

    def __init__(
            self,
            logger: LoggerABC,
            bot: DiscordBotServiceABC,
            servers: ServerRepositoryABC,
            auto_roles: AutoRoleRepositoryABC,
            reaction_handler: ReactionHandler
    ):
        OnRawReactionAddABC.__init__(self)

        self._logger = logger
        self._bot = bot
        self._servers = servers
        self._auto_roles = auto_roles
        self._reaction_handler = reaction_handler

    async def on_raw_reaction_add(self, payload: RawReactionActionEvent):
        self._logger.debug(__name__, f'Module {type(self)} started')

        await self._reaction_handler.handle(payload, 'add')

        self._logger.debug(__name__, f'Module {type(self)} stopped')
