import discord
from cpl_query.extension import List
from cpl_translation import TranslatePipe
from discord import ui, TextStyle

from bot_core.abc.message_service_abc import MessageServiceABC
from bot_core.logging.command_logger import CommandLogger
from modules.stats.model.statistic import Statistic


class AddStatisticForm(ui.Modal):

    description = ui.TextInput(label='Beschreibung', required=True)
    code = ui.TextInput(label='Code', required=True, style=TextStyle.long)

    def __init__(
            self,
            stats: List[Statistic],
            name: str,
            message_service: MessageServiceABC,
            logger: CommandLogger,
            t: TranslatePipe,
    ):
        ui.Modal.__init__(self, title=name)

        self._stats = stats
        self._name = name
        self._message_service = message_service
        self._logger = logger
        self._t = t

    async def on_submit(self, interaction: discord.Interaction):
        self._stats.append(Statistic(self._name, self.description.value, self.code.value))
        await self._message_service.send_interaction_msg(interaction, self._t.transform('modules.stats.add.success'))
        self._logger.trace(__name__, f'Finished stats command form')
